#{extends 'borderNG.html' /}

#{set 'titleHead'}
&{'lelang_doc.edit_tender'}
#{/set}

<ol class="breadcrumb">
	<li><a href="@{BerandaCtr.index()}">&{'lelang_doc.hom'}</a></li>
    #{if lelang.lls_status.draft}
	<li><a href="@{lelang.PaketCtr.index()}">Daftar Paket </a></li>
	<li><a href="@{lelang.LelangCtr.edit(lelang.lls_id)}">&{'lelang_doc.edit_tender'}</a></li>
    #{/if}
    #{else}
    <li><a href="@{lelang.LelangCtr.view(lelang.lls_id)}">&{'lelang_doc.info_tender'}</a></li>
    #{/else}
	<li class="active">&{'lelang_doc.perubahan_doc_pemilihan'}</li>
</ol>

<div class="content">
	#{form @lelang.DokumenCtr.cetak(lelang?.lls_id), id:'form-dok-lelang', 'data-alert':'true'}
	#{alert /}
	<div class="float-right clearfix">
		#{saveButton title:'Cetak Dokumen' /}
		#{backButton action:@lelang.LelangCtr.edit(lelang.lls_id) /}
	</div>
	#{/form}
	<div class="clearfix"></div>	
	<ul class="nav nav-tabs">
      <li #{if activetab=="hps"}class="active" #{/if}><a href="#hps" data-toggle="tab">&{'lelang_doc.rincian'}</a></li>
	  #{if !lelang.pemilihan.lelangExpress}
	  <li #{if activetab=="ldk"}class="active" #{/if}><a href="#ldk" data-toggle="tab">&{'lelang_doc.lembar_data_kualifikasi'}</a></li>
	  #{/if}
	  <li  #{if activetab=="ldp"}class="active" #{/if} #{if lelang.pemilihan.lelangExpress} #{/if}><a href="#ldp" data-toggle="tab">&{'lelang_doc.lembar_data_pemilihan'}</a></li>
	  #{if !lelang.pemilihan.lelangExpress}
	  <li #{if activetab=="checklist"}class="active" #{/if}><a href="#checklist" data-toggle="tab">&{'lelang_doc.persyaratan_doc'}</a></li>
	  #{/if}	  
	  <li class="nav-item"><a class="nav-link #{if activetab=='spek'} active #{/if}" href="#spek" data-toggle="tab">#{if kategori.konsultansi || kategori.jkKonstruksi || kategori.konsultansiPerorangan} Kerangka Acuan Kerja (KAK)#{/if} #{else} Spesifikasi Teknis dan Gambar #{/else}</a></li>
	  <li class="nav-item"><a class="nav-link #{if activetab=='sskk'} active #{/if}" href="#sskk" data-toggle="tab">SSKK</a></li>
	</ul>
	<div class="tab-content">
      <div class="tab-pane #{if activetab=="hps"}active #{/if}" id="hps">
      	#{include 'lelang/dokumen/form-hps.html' /}
      </div>
	  #{if !lelang.pemilihan.lelangExpress}
	  <div class="tab-pane #{if activetab=="ldk"}active #{/if}" id="ldk">
			<div class="bs-callout bs-callout-warning">
				&{'lelang_doc.petunjuk'}<br />
				<ol>
					<li>&{'lelang_doc.petunjuk_1'}</li>
					<li>&{'lelang_doc.petunjuk_2'}</li>
				</ol>
			</div>
			#{form @lelang.DokumenCtr.simpan(lelang?.lls_id), id:'form-dok-lelang', 'data-alert':'true'}
			<input type="hidden" id="activetab" name="activetab" value="ldk" />

			#{if editable}
			<div class="clearfix"></div>
			#{saveButton /}
			#{/if}
			#{/form}
	  </div>
	  #{/if}
	  <div class="tab-pane #{if activetab=="ldp"}active #{/if}" id="ldp">
	    #{include 'lelang/dokumen/form-ldp.html' /}
	  </div>
	   #{if !lelang.pemilihan.lelangExpress}
	  <div class="tab-pane #{if activetab=="checklist"}active #{/if}" id="checklist">
	  	<div class="bs-callout bs-callout-info">&{'lelang_doc.pilih_daftar_dokumen'}</div>
	  	#{form @lelang.DokumenCtr.simpan(lelang?.lls_id), id:'form-dok-lelang', 'data-alert':'true'}

	  	<input type="hidden" id="activetab" name="activetab" value="checklist" />
		#{saveButton /}
		#{/form}
	  </div>
	  #{/if}      
	  <div class="tab-pane #{if activetab=="sskk"}active #{/if}" id="sskk">
      	#{if lelang.pemilihan.lelangExpress}
        	#{include 'lelang/dokumen/form-sskk-express.html' /}
      	#{/if}
        #{else}
	  		#{include 'lelang/dokumen/form-sskk.html' /} 
        #{/else}
	  </div>
	  <div class="tab-pane #{if activetab=="spek"}active #{/if}" id="spek">
		#{include 'lelang/dokumen/form-spek.html' /}
	  </div>  
	</div>
</div>

#{if editable}
#{set 'css_custom' }
<link href="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/css/jquery.fileupload.min.css" rel="stylesheet" type="text/css">
<link href="#{assets '/handsontable/handsontable.full.min.css'/}" rel="stylesheet" type="text/css">
#{/set}
#{/if}

#{set 'custom_script'}
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/vendor/jquery.ui.widget.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.iframe-transport.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-process.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-validate.min.js"></script>
<script type="text/javascript" src="#{assets '/js/form.util.js'/}"></script>
<script type="text/javascript" src="#{assets '/js/evaluasi_teknis.js'/}"></script>
#{if editable}
<script type="text/javascript">  
#{if kategori.konsultansi || kategori.jkKonstruksi} 
var badanUsaha = true;
#{/if}
#{elseif kategori.konsultansiPerorangan}
var badanUsaha = false;
#{/elseif}
/*var total_nilai_pengalaman = 0;
		
		var subunsur_pengalaman_sejenis = 0;
		var subunsur_pengalaman_selokasi = 0;
		var subunsur_pengalaman_manajerial = 0;
		var subunsur_kapasitas_perusahaan = 0;
		var subunsur_lain_pengalaman = 0;
*/		
#{if sskk_content.pemutus_sengketa=='Badan Arbitrase Nasional Indonesia'} $(".bani_sengketa").show(); #{/if}
	#{else} $(".bani_sengketa").hide(); #{/else}

	$("#pemutus_sengketa").on("change", function(){
		var badan = $(this).val();
		if(badan == 'Badan Arbitrase Nasional Indonesia')
			$(".bani_sengketa").show();
		else 
			$(".bani_sengketa").hide();
	});
	$(document).on('click', '#fileupload', function(){
			 	$('#fileupload').fileupload({
		        url: '@{lelang.DokumenCtr.spekSubmit(lelang?.lls_id)}',
		        dataType: 'json',
		        acceptFileTypes: /(\.|\/)(txt|doc|docx|xls|xlsx|pdf|gif|jpe?g|png|zip|rar|rtf)$/i,
		        done: function (e, data) {
		            $.each(data.result.files, function (index, file) {
						var content = file.name+' <a href="javascript:void(0)" class="removeDok" versi="'+file.versi+'"><i class="fa fa-trash-o" ></i></a>';
		                $('<li/>').html(content).appendTo('#files');
		            });
		            $('#progress').hide();
		            $('#alert-upload').hide();
		        },
		        progressall: function (e, data) {
		            var progress = parseInt(data.loaded / data.total * 100, 10);
		            $('#progress').show();
		            $('#progress .progress-bar').css(
		                'width',
		                progress + '%'
		            );
		        }       
		    }).on('fileuploadprocessalways', function (e, data) {
		    	var file = data.files[data.index];
		    	if (data.files.error && file.error) {
		    	  var msg = file.name+' - '+file.error
			      $('#alert-upload').attr('class', 'alert alert-danger').html(msg)   
			    }       
		    }).prop('disabled', !$.support.fileInput).parent().addClass($.support.fileInput ? undefined : 'disabled');
		 })    
	    
	   $(document).on('click', '.removeDok', function(){
	   	  var versi = $(this).attr('versi')
	   	  var parent = $(this).parent()
	   	  var source  = #{jsRoute @lelang.DokumenCtr.hapusSpek(lelang?.lls_id) /};
	      $.ajax({
			  type: 'POST', 
			  url: source.url(),
			  data : {'versi': versi},
			  success : function(){
				  $('#alert-upload').attr('class', 'alert alert-success').html('&{'flash.ftbdh'}');
		  	 	parent.remove()
			  },
			  error : function(){
				  $('#alert-upload').attr('class', 'alert alert-danger').html('&{'flash.ftdkdbh'}');
			  }
		  })
	   });  

</script>
#{/if}
<!-- rincian hps -->
<script type="text/javascript" src="#{assets '/handsontable/handsontable.full.min.js'/}"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/PapaParse/5.1.0/papaparse.min.js"></script>
<script type="text/javascript">
  var data = ${data?.raw()};
  var interval = 2 * 60 * 1000; // 2 menit
  var total = 0;
  var fixed = true;
  var activetab = 'hps';
  $(document).on('change','#rincian_upload', function(evt) {
	 	 
	  var file = evt.target.files[0]; 	   
	  var reader = new FileReader();
	  reader.onload = function(progressEvent){
	    var lines = this.result.split('\n');
	    var rows = lines.length;
	    var foundSeparator = false;
	    var validAll = true;
	    var firstSeparator ="d";
	    for(var line = 0; line < rows ; line++){
	    	if(lines[line].length > 0){
	    		//console.log("========================================================> record :"+line)
	    		//console.log(lines[line]+" : line => "+line);
		  	      var coma = (lines[line].indexOf(",") > 0);//found
		  	      var seco = (lines[line].indexOf(";") > 0);//found		  	      
		  	      //console.log(coma + " : "+ seco);
		  	      if(coma && seco ){
		  	    	  validAll=false;
		  	    		break;//exit for
		  	    	  // console.log('bad 2 found');
		  	      }else if(coma || seco ){
		  	    	  if(firstSeparator=="d"){
		  	    		  //firs found separator is?
		  	    		  if(coma){
		  	    			  firstSeparator=",";
		  	    	//		  console.log("koma");
		  	    		  }
		  	    		  if(seco){
		  	    			  firstSeparator=";";
		  	    	//		  console.log("koma");
		  	    		  }
		  	    	  }else{
		  	    		  //console.log(firstSeparator);
		  	    		  //not valid if previous separator is diferent
		  	    		  if(coma && (firstSeparator != ",")){
		  	    			  validAll=false;//
		  	    				break;//exit for
		  	    		  }
		  	    		  if(seco && (firstSeparator!= ";")){
		  	    			  validAll=false;
		  	    				break;//exit for
		  	    		  }			  	    		
		  	    		//console.log(coma + " " + (firstSeparator==","))
		  	    		//console.log(seco + " " + (firstSeparator==";"));
		  	    	  }
		  	    }
	  	    	//console.log("========================================================> END record :"+line)
	    	}
	    }//end for	    
	    //console.log(validAll+" valid all")
	    if(validAll){
	    	parseCsvLoadHandsontable(file);
	    }else{
	    	alert("File HPS Anda memiliki format yang tidak valid.");
	    }
	    $('input[type=file]').val("");
	  };
	  reader.readAsText(file);
	  
  });  
  
  function parseCsvLoadHandsontable(file){
	  Papa.parse(file, {
	      //header: true,
	      //asep
	      delimiter: "",	// auto-detect
		  newline: "",	// auto-detect
	      dynamicTyping: true,
	      complete: function(results) {
	    	var res = results.data;
	        var obj = new Array();
	        for(i=1;i<res.length;i++){
	        	
	        	var totalharga = 0;
	        	var pajak = 0;
	        	
	        	if(!parseInt(res[i][2], 10)){	 	        		
	        		res[i][2]=0;	        		
	        	} else{	        		
	        		totalharga = res[i][2] * res[i][5];
	        	}
	        	//
	        	// if(!parseInt(res[i][4], 10)){
	        	// 	//console.log("vol2 not null");
	        	// 	res[i][4]=1;
	        	// }
	        	// if(res[i][4] > 0){
	        	// 	console.log("if 2 :"+parseInt(res[i][2], 10))
	        	// 	totalharga = res[i][2] * res[i][4] * res[i][5];
	        	// }
	        	
	        	//pajak ga boleh null
	        	if(!parseInt(res[i][4], 10)){
	        		res[i][4]=0;
	        	}
	        	if(res[i][4] > 0){
	        		pajak = (res[i][4] / 100) * totalharga;
	        		totalharga +=pajak;	
	        	}
	         	obj.push({
	         		item: replaceChar(res[i][0]), 
	         		unit: replaceChar(res[i][1]), 
	         		vol:res[i][2], 
	         		// unit2: replaceChar(res[i][3]),
	         		// vol2:res[i][4],
	         		harga:res[i][3],
	         		pajak:res[i][4],
	         		//asep:total to auto
	         		//total_harga:res[i][7],	         		
	         		total_harga:totalharga,
	         		keterangan: replaceChar(res[i][5]) })
	        }
	        $("#tbl-rincian").handsontable("loadData", obj);
	       	summary();
	      }
	    });
  }
	
  function replaceChar(str){
	  var strs ="";
	  strs +=str;
	  return strs.replace(/[^a-zA-Z0-9.,!@#$%&@*()-+=/\-\s ]/g,"");
  }
  function summary() {
	  var data = $("#tbl-rincian").data('handsontable').getData();
	  var total_hps = 0;
	  var total = 0;
	  for (i = 0; i < data.length; i++) {
		  if (data[i].total_harga)
			  total += parseFloat(data[i].total_harga);
	  }
	  if (total > 0) {
		  total_hps = parseFloat(total);
	  }
	  $("#rekap").find("#total_hps").text(toRupiah(rounded2Decimal(total_hps)));
  } 
 
 if(data.length == 0) {	 
 	data.push({item:"", unit:"", vol:1, unit2:"", vol2:1, harga:0, pajak:10, total_harga:0, keterangan:""});
 }
 
 $("#tbl-rincian").handsontable({
   rowHeaders: true,
   dataSchema : {item:"", unit:"", vol:1, unit2:"", vol2:1, harga:0, pajak:10, total_harga:0, keterangan:""},
   data: data,
   #{if editable}
   contextMenu : {
	   items : {
		   "row_above" : { name : "Tambah Baris Diatas"},
		   "row_below" : { name : "Tambah Baris Dibawah"},
		   "remove_row" : { name : "Hapus Baris"},
		   "undo":{name : "Undo"}, 
		   "redo":{name : "Redo"}
	   }
   },
   #{/if}
   columns: [{data:'item', width:200, title: 'Jenis Barang/Jasa'}, 
             {data:'unit', width:100, title: 'Satuan'}, 
             {data:'vol', type:'numeric', format:'0,0.00', width:50, title:'Vol'}, 
             // {data:'unit2', width:100, title : 'Satuan 2'},
             // {data:'vol2', type:'numeric', format:'0,0.00', width:50, title:'Vol 2'},
   			 {data:'harga', type:'numeric',format:'0,0.00', width:100, title : 'Harga'},	
   			 {data:'pajak', type:'numeric',format:'0,0.00', width:60, title : 'Pajak (%)', dataSchema : 10}, 
   			 {data:'total_harga', type:'numeric', format:'0,0.00', width:100, title : 'Total'}, 
   			 {data:'keterangan', width : 250, title : 'Keterangan'}],

   	
    cells : function(row, col, prop) {
    	var cellProperties = {};
    	#{if editable}
        if (col == 5 ) {
            cellProperties.readOnly = true;
        }
        if(data[row] && (col == 2 || col == 3 || col == 4)) {
            var total = 0;
            if(data[row].harga > 0)
                total = data[row].harga;
            if(data[row].vol > 0)
                total = total * data[row].vol;
            if(data[row].pajak > 0)
            	total = total + ((total * data[row].pajak) / 100);
            else
                data[row].pajak = 0;
            if(total > 0)
                data[row].total_harga = rounded2Decimal(total);
        }
        if(data[row] && (col == 1 || col == 2 || col == 6)) {
        	data[row].item = replaceChar(data[row].item);
        	data[row].unit = replaceChar(data[row].unit);
        	data[row].keterangan = replaceChar(data[row].keterangan);
        }
        #{/if}
        #{else}
        cellProperties.readOnly = true;
        #{/else} 
        return cellProperties;
    },    	
  	afterChange: function (change, source) {
   	    summary();
   	}
 });
 $("#fixed").on('change', function () {
 	fixed = this.checked ? false:true;
 });
 #{if editable}
 $("#simpan").click(function () {
 	autosave();
 }); 
 function autosave() {
 	var postdata = $("#tbl-rincian").data('handsontable').getData();
 	var token = $("input[name='authenticityToken']").val();
    $.ajax({
          url: '@{lelang.DokumenCtr.hpsSubmit(lelang.lls_id)}',
          data: {"data": JSON.stringify(postdata), "fixed": fixed, "activetab":activetab, "authenticityToken": token},
          type: 'POST',
          success: function (res) {         	
 	        if (res.result === 'ok')
                $('#alert').html('<div class="alert alert-success">Data berhasil tersimpan</div>');
 	        else if(res.result.length > 0)
                $('#alert').html('<div class="alert alert-danger">'+res.result+'</div>');
 	        else
                $('#alert').html('<div class="alert alert-danger">Data gagal tersimpan, mohon periksa kembali inputan Anda</div>');
      	},
          error: function () {
              $('#alert').html('<div class="alert alert-danger">Data gagal tersimpan karena ada kendala jaringan/server</div>');
         }
    });
 }
 setInterval(autosave, interval);
 #{/if}
</script>
#{/set}

